package com.liang.service;

import com.liang.entity.PrjApproverecord;
import com.liang.entity.StaBudgetapproval;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 科技项目审批(PrjApproverecord)表服务接口
 *
 * @author makejava
 * @since 2023-05-03 13:23:12
 */
public interface PrjApproverecordService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjApproverecord queryById(Integer id);

    /**
     * 分页查询
     *
     * @param prjApproverecord 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    Page<PrjApproverecord> queryByPage(PrjApproverecord prjApproverecord, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjApproverecord 实例对象
     * @return 实例对象
     */
    int insert(PrjApproverecord prjApproverecord);

    int insertBatch(List<PrjApproverecord> recordList);

    /**
     * 修改数据
     *
     * @param prjApproverecord 实例对象
     * @return 实例对象
     */
    int update(PrjApproverecord prjApproverecord);

    /**
     * 修改费用申请撤销时的状态为完成
     *
     * @param xmid
     * @return
     */
    int updateRevokeRecord(int xmid);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取待审批列表
     *
     * @return
     */
    List<PrjApproverecord> getApproveList(Map map);

    /**
     * 根据项目ID获取待审批记录
     *
     * @return
     */
    List<PrjApproverecord> getApproveByXmId(Map map);

    /**
     * 新增数据
     *
     * @param
     * @return 影响行数
     */
    int insertApprove(List<PrjApproverecord> recordList);

    /**
     * 根据项目ID获取待审批记录
     *
     * @return
     */
    List<PrjApproverecord> getApproveByXmId2(Map map);

    PrjApproverecord getOldApproveRecord(Integer id);

    List<PrjApproverecord> getPrjAnnualBudgetRecordList(String userId);

    List<PrjApproverecord> getPrjProjectRecordRecordList(String userId);

    List<PrjApproverecord> getprjContractRecordList(String toString);

    void updatSpList(String id,Integer userId);
}
